# Changelog

## 4.6.1

- Improve support for entering-zoom

## 4.6.0

- Add external IDs

## 4.5.3

- Update browser support to fit to new mapwize specs
- Update mapbox gl dependencie to 1.13.1

## 4.5.2

- Fix: geojson layers throw js error

## 4.5.1

- Fix: remove `beforeunload` listener when remove the map
- Fix: setLanguage error
- Add issue api methods
- Add min/maxZoom options to setStyle methods

## 4.5.0

- Update connector style to handle translated floor
- Handle server side configuration for title display property
- Add title display in setStyle method
- Add title in setStyle method

## 4.4.4

- Fix container destroyed when calling map.remove()

## 4.4.3

- Fix broken version (4.4.2)

## 4.4.2

**Broken version fixed in 4.4.3**

- Improving map remove process

## 4.4.1

- Fixing collision between user location dot and other symbols

## 4.4.0

- Improving the place selection capability. The select will add a pin, highlight the name and color the boundary of the place. This feature intend to replace the place promote feature.
- Fix: Selected place blur effect
- Fix: Marker icon size
- Preparing the migration to the latest version of Mapbox. **Warning, IE11 will be dropped in the next major release**

## 4.3.2

- Adding possibility to select a place. The select will add a pin, highlight the name and color the boundary of the place. The methods selectPlace and unselectPlace are now available.
- Adding options to customize the direction lines and marker :
  - backgroundLineOptions
  - foregroundLineOptions
  - startMarkerOptions
  - endMarkerOptions
- Fixing place icon not shown when promoting a place
- Adding api method to fetch place details

## 4.3.1

- Fix: bug when using `names`, `pick`, ... options in Mapwize.Api

## 4.3.0

- Fix: error when displaying directions
- Feat: add telemetry
- Feat: add browser compatibility check (with option to disable it)
- Improve tests
- Upgrade dependencies

## 4.2.10

- Feat: adding option to prevent the Mapwize Logo from being clickable
- Change: chaning the option to move the Mapwize Logo
- Feat: adding getLngLatFloor and setLngLatFloor methods on Markers allowing to moving them dynamically

## 4.2.9

- Feat: add support of minZoom and maxZoom on connectors
- Fix: display promoted places at all zoom levels
- Upgrade dependencies

## 4.2.8

- Fix: venue in the middle of the screen must be displayed in priority

## 4.2.7

- Fix: `setUniverseForVenue` fail for venues not already loaded/displayed

## 4.2.6

- Fix: markerDisplay = true didn't work in setPlaceStyle methods when it's set to false in studio
- Feat: Add support for minZoom and maxZoom propeties for layers and places
- Upgrade dependencies
- Upgrade mapbox-gl to 1.9.1

## 4.2.5

- Fix: upgrade Mapwize dependencie to fix Mapbox issue on Windows in v1.8.0
- Fix: setPlaceStyle marker image not displaying
- Improvement: setPlaceStyle does not use the proxy anymore
- Improvement: setPlaceStyles requesting markerUrl only once

## 4.2.4

**Bug on Windows fixed in 4.2.5**

- Fix: direction path now displayed on top of the place polygons
- Logging version in console to simplify debugging

## 4.2.3

**Bug on Windows fixed in 4.2.5**

- Fix: timeout error when run browserstack tests
- Upgrade mapbox-gl to 1.8.0

## 4.2.2

- Fix: cannot promote same place multiple times
- Upgrade dependencies

## 4.2.1

- Fix: catch internal errors when loading venue content
- Improvement: `addMarkerOnPlaceList` now uses `/v1/placeLists/{placeListId}/places` to reduce network traffic

## 4.2.0

- Fix: Display of promoted places outside venues
- Fix: Display of place stroke depends on zoom level
- Fix: error.captureStackTrace isn't available in all browsers
- Fix: catch setFollowUserMode error to avoid errors in console
- Upgrade dependencies

## 4.1.2

- Fix: Display of promoted invisible places

## 4.1.1

- Fix: Always use options if set (bearing, pitch, zoom) when using centerOnVenueId and centerOnPlaceId
- Fix: documentation

## 4.1.0

- Reviewed browser compatibility
- Fix: Don't interrupt map initialization in case of access key error
- Fix: Cache data source not working
- Fix: floorForVenue option not taken into account when using centerOnVenueId option
- Fix: setFloor refreshing display when setting current floor
- Feat: Add mapwize:languagechange event
- Improvement: UMD build now contains a package name
- Improvement: mapwize:error event now sends typed error instances

## 4.0.1

- Refactor: merged mapboxOptions and mapwizeOptions into a single options object.

## 4.0.0

This new version focusses on performance! The rendering engine has been completely redesigned while we have tried to keep the usage of the SDK as close as possible to the previous version to make migration as easy as possible. An extensive JSDoc is now generated and available at docs.mapwize.io.

### UI

- `FloorControl`, `LocationControl` and `NavigationControl` have been moved into Mapwize UI. There is no more user interface in Mapwize SDK.

### Dependencies

- Upgraded mapbox-gl to 1.4.1

### Features

- Add: `getUniverses()` method
- Add: `addMarkerOnPlaceList(placeList, marker)` method
- Add: `addPromotedPlaceList(placeList)` method
- Add: `removePromotedPlaceList(placeList)` method
- Add: `removePromotedPlaces()` method
- Add: `setPromotedPlaces(places)` method
- Add: `getPromotedPlaces()` method
- Refactor: `setPlaceStyle(place, style)` and `setPlaceStyles(styles)` now support `markerDisplay` and `polygonDisplay` options to show/hide place marker and polygon
- Add: `removePlaceStyles()` method
- Add: `getUserHeading()` method
- Add: `getDirection()` method
- Add: `userHeading` option

### Floor methods

- Refactor: `setFloorForVenue(floor, venueId, eventParams)` now only accepts string for param venueId
- Refactor: `getFloorForVenue(venueId)` now only accepts string for param venueId
- Refactor: `getFloorsForVenue(venueId)` now only accepts string for param venueId

### Language methods

- Refactor: `setLanguageForVenue(language, venueId)` now only accepts string for param venueId
- Refactor: `getLanguageForVenue(venueId)` now only accepts string for param venueId
- Remove: `getDefaultLanguageForVenue(venue)` method

### Universe methods

- Feat: `setUniverse(universeId, eventParams)` now accepts `eventParams` param
- Feat: `setUniverseForVenue(universeId, venueId, eventParams)` now accepts `eventParams` param
- Refactor: `getUniverseForVenue(venueId)` now only accepts string for param venueId
- Refactor: `setUniverseForVenue(universeId, venueId, eventParams)` now only accepts string for param venueId
- Remove: `getDefaultUniverseForVenue(venue)` method
- refactor: `setUniverseForVenue` now returns a promise
- refactor: `getUniverseForVenue` now returns a promise

### Promote methods

- Remove: `removePromotedPlacesForVenue(venue)` method. Use `removePromotedPlaces()`

### User location methods

- Rename: `setUserPosition(position)` into `setUserLocation(location)`
- Rename: `getUserPosition()` into `getUserLocation()`

### Api

- Refactor: `getMainSearchesForVenue(venueId)` now only accepts string for param venueId
- Refactor: `getMainFromsForVenue(venueId)` now only accepts string for param venueId

### Other methods

- Remove: `getPlace`, use `Mapwize.Api.getPlace` instead
- Refactor: `fitBounds` remove `minZoom` option

### Events

- Refactor: `mapwize:directionstart` event param move from `directions` to `direction`

### Map options

- Remove: `bounds`, `boundsOptions` and `boundsEventsData` from mapwize options, use mapbox options instead
- Rename: `mapwizeOptions.color` into `mapwizeOptions.mainColor`
- Remove: `floorControl` and `floorControlOptions`
- Remove: `userLocation`, `useBrowserLocation`, `userLocationControl` and `userLocationControlOptions`

## 3.5.0

- Fix IE11 compatibility
- Fix issue with map refresh method

## 3.4.5

- Fix: fillOpacity in setPlace(s)Style methods
- Fix: stop checking for venue changes after remove
- Upgrade mapbox-gl dependency to 1.0.0
- Feat: add getPlace method
- Feat: introduce dataSource configuration

## 3.4.4

- Fix: stroke not displaying on some objects on GeoJSON layers

## 3.4.3

- Fix: broken places order

## 3.4.2

- Improving the documentation on how to use your own Mapbox outdoor map
- Adding a link to Mapwize UI in the documentation

## 3.4.1

- Fix: missing venue attribute in place objects

## 3.4.0 (Broken version, use 3.4.1+)

- Feat: add realtime venue refresh system
- Feat: implement remove method to kill the mapwize map instance and datas
- Refactor: switch to new api content

## 3.3.2

- Fix: error on floor selector when leave a venue
- Fix: add type on floor selector button to fix bad comportement when integrated with jquery
- Fix: cannot change markerUrl with setPlace(s)Style methods

## 3.3.1

- Feat: floor selector with long names
- Fix: layers transition

## 3.3.0

- Refactor: User Position on floor null should always be pink
- Refactor: merge `mapwize:markerclick` in `mapwize:click` event

#### /!\ POSSIBLE BREAKING CHANGE /!\

`mapwize:markerclick` event has been removed. Use `mapwize:click` event

Before:

```javascript
map.on('mapwize:markerclick', (e) => {
	console.log('clicked on marker', e.marker)
})
```

After

```javascript
map.on('mapwize:click', (e) => {
	console.log('clicked on marker', e.marker)
})
```

Pay attention, `mapwize:click` event is called in multiple cases like: click on a marker, click on a place, click on a venue or click on the map.  
The event object contains everything that is under your mouse.

## 3.2.1

- Refactor: change controls order and expose them

## 3.2.0

- Upgrade dependencies
- Fix: center on venue
- Feat: add bounds options to center the map on bounds at start (`bounds`, `boundsOptions` and `boundsEventsData` available in MapwizeOptions)
- Feat: new map contructor method

#### /!\ DEPRECIATION WARNING /!\

The old method to create a map instance is now deprecated. Please, use the new method for new projects.

Before:

```javascript
Mapwize.apiKey('<YOUR_MAPWIZE_API_KEY_HERE>')
const map = new Mapwize.Map({
	container: 'mapwize',
})

map.on('mapwize:ready', () => {
	// Mapwize map is now ready to be used
})
map.on('mapwize:loaderror', (err) => {
	// Something bad happened during Mapwize loading
	console.error(err)
})
```

After

```javascript
Mapwize.apiKey('<YOUR_MAPWIZE_API_KEY_HERE>')
Mapwize.map({
	container: 'mapwize',
})
	.then((map) => {
		// Mapwize map is now ready to be used
	})
	.catch((err) => {
		// Something bad happened during Mapwize loading
		console.error(err)
	})
```

## 3.1.9

- Improvement: add browser support in documentation
- Improvement: use base64 icons (perf improvement)
- Improvement: add `floor` option on `centerOnVenue`method
- Improvement: `centerOnVenue`, `centerOnPlace` and `centerOnUser` now return a Promise which will be resolved once the map move end event fired

## 3.1.8

- Feat: add mapwize:directionstart and mapwize:directionstop events
- Improvement: add JsFiddle examples in doc

## 3.1.7

- Improve: optimize setPlaceStyle
- Feat: add setPlacesStyle to customize place style in batch

## 3.1.6

- Fix: User heading on mobile device

## 3.1.5

- Fix: map.getFloor now return null when called in `mapwize:venueexit` event
- Fix: Style (fill & stroke) opacity not taken into account if 0
- Improvement: import only necessary turf modules to reduce package weight
- Feat: Option to customize color (directions, floor selector, user position, marker)
- Feat: support `defaultFloor` for venue

## 3.1.4

- Fix: Venue icon appears while in venue
- Fix: documentation
- Fix: centerOnPlace when we are out of venue
- Add: some example files for demo prupose
- Add: webpack dev files for maps
- Add: mapwize:venueentererror, mapwize:loaderror events
- Refactor: error management with HttpResponseError class
- Refactor: venue state management, clean code and fix multiple venue copy
- Refactor: simplify promise usage

## 3.1.3

- Fix: hide outdoor direction when exit venue

## 3.1.2

Fix: display places on floor null
Fix: display directions on floor null

## 3.1.1

Fix: export mapwize as umd package
Fix: setPlaceStyle now accept `null` as style param

## 3.1.0

First public release of the new Mapwize JS SDK based on Mapbox GL JS

## Version 2.6.2

- Preventing long directions from exiting venue
- Making data available in beacons

## Version 2.6.1

- Use venue defaultCenter and defaultZoom
- Add Mapwize attribution link
- Fix latitude, longitude and floor can be negative in url parser
- Update doc to better fit in docs.mapwize.io

## Version 2.6.0

- Using outdoor.mapwize.io by default for the outdoor map
- The `outdoorMapProvider` map option has been removed. Use `OUTDOOR_TILES_URL` in the config instead.

## Version 2.5.0

- Changing floors behaviour to only have in the floor selector the floors for which there is a layer visible on the screen. Changed the behaviour of getFloors and floorsChange accordingly.

## Version 2.4.1

- Prevent crash on browsers not supporting playing with document.styleSheets
- Prevent firing venueExit with empty content
- Use api.mapwize.io by default
- Load first accessible universe by default
- Add demo with 2 maps on the same page

## Version 2.4.0

- Added support for decimal floors
- Url parser now returns the venue for place or beacon urls for which the place or beacon is not found
- Fix media permission issue on Firefox

## Version 2.3.7

- Fix bug with useBrowserLocation map option
- Add support for dashes (-) in object alias

## Version 2.3.6

- Improved floor control

## Version 2.3.5

- Fix analytics custom dimensions
- Fix order in places display
- Fix bug on order for outdoor layers
- Improved performances
- Improved API error handling

## Version 2.3.4

- Improved analytics
- Fix issue with followUserMode being disabled when it should not
- Fix compatibility issue with IE11

## Version 2.3.3

- Fix: main color also affect user position

## Version 2.3.2

- Fix bad style on direction change floor marker on some devices

## Version 2.3.1

- Added bounds map options

## Version 2.3

- Added support for external places
- Added support for changing user position and directions color
- Added support for customizing default marker icon

## Version 2.2

- Added support for outdoor layers to be displayed on all floors
- Added support for GeoJSON layers
- Added API method getVenuesForOrganization and search
- Improved documentation

## Version 2.1

- Migrating to Leaflet 1.0.3 from 0.7. This can bring breaking changes if you are using Leaflet features directly. Please refer to the [Leaflet documentation](http://leafletjs.com/reference-1.0.3.html).
- Adding multi-point directions. It is now possible to optimize a path with multiple waypoints.
- Adding minZoom param on fitBounds
- Fix bad center on venue zoom on large venues
- Mapwize images (like qrCode and user position button) are now embedded in css
- New direction path style
- [Breaking change] Api.getDirections is now taking an array of waypoints (from, to, waypoints, directionOptions, cb). Backward compatibility has been kept on the map.showDirections function.
- General improvements and bugs fixes

## Version 2.0.2

- Optimized performances deep inside
- Added advanced parser for Mapwize URL
- Added configuration for outdoorMapProvider

## Version 1.7.1

- Renamed Mapwize.api to Mapwize.Api
- Introducing Mapwize.Location service
- Added support for isVisible and isClickable places
- Added support for custom connector icons
- Added callbacks in asynchronous methods

## Version 1.6.1

- Improvements to the initialization sequence
- Demo building now requires an accessKey

## Version 1.6

- Support for multilingual venues
- Support for storing custom "data" on venues, places, placeLists and beacons
- Added callback on Mapwize.map
- Introducing venueEnter and venueExit events

## Version 1.5

- Possibility to request shortest path to list of places (closest place of list is automatically selected)
- Places and layers are displayed at zoom 16 instead of 18
- Improved display of the outdoor places and directions
- Added Mapwize.api methods
- General improvements

## Version 1.4.4

- Bug fix getLayers
- Bug fix setStyle
- Bug fix scroll floor control

## Version 1.4.3

- Bug fix
- Improved caching
- Setting the right user position while loading direction URLs

## Version 1.4.2

- Places are displayed in the order defined on the server.

## Version 1.4.1

- Added possibility to display user heading
- Added a cache system to reduce the network traffic. Use map.refresh to force the refresh of the cache.
- Margins can be set to free the top and bottom of the map.
- Place style can be modifyed in real-time
