# Mapwize.js

This is the Mapwize Javascript SDK. 

The SDK allows you to:

- Display the map of buildings, with all floors and places.
- Add your own data on the map.
- Locate the user inside the building.
- Display directions between 2 points, across multiple floors.

__This SDK only comes with the core map view and API and is intended for the advanced Mapwize integrations. For a first integration of Mapwize in your project, please consider Mapwize UI.__

## Open-source Mapwize UI

If you are looking for a fully featured and ready to use View to add Mapwize Indoor Maps and Navigation in your web app, have a look at [Mapwize UI](https://github.com/Mapwize/mapwize-ui-js). This open-source project enriches the core SDK with interfaces for search and directions, that you can use as is or modify to your taste.

We are ourselves using [Mapwize UI](https://github.com/Mapwize/mapwize-ui-js) to build [maps.mapwize.io](https://maps.mapwize.io).

## Access to the platform

To get your access to the platform (API and Studio to create your own maps), sign up at [mapwize.io](https://www.mapwize.io)

## Mapbox

The SDK is built on top of [Mapbox GL JS](https://www.mapbox.com/mapbox-gl-js). The underlying Mapbox map is made available so you can take advantage of all the powerful features provided by Mapbox for data visualization.
 
Mapbox GL JS is included in the package so you don't have to worry about importing it. Mapwize.js is all you need.

## Documentation

The complete SDK documentation can be found at [docs.mapwize.io](https://docs.mapwize.io).

## Support

For any question or request, please contact us at <support@mapwize.io>.
